import { useState, useEffect, useCallback } from 'react';
import { useScript as useScript$1 } from 'usehooks-ts';
import useScript$2 from 'react-script-hook';

var useLoadScript = function (_a) {
  var script = _a.script;
  var status = useScript$1(script);
  var _b = useState(false),
    init = _b[0],
    setInit = _b[1];
  useEffect(function () {
    if (status !== "ready") return;
    setInit(true);
  }, [status]);
  return {
    init: init
  };
};

var MANIFEST_SCRIPT = 'https://bridge.usemanifest.com/Manifest.js';

var useManifestBridge$3 = function (config) {
  var _a = useState(),
    manifest = _a[0],
    setManifest = _a[1];
  var status = useScript$1(MANIFEST_SCRIPT);
  useEffect(function () {
    console.log({
      status: status
    });
    if (status === "loading") return;
    if (status === "error") {
      console.error("Error loading Manifest");
      return;
    }
    if (status === "ready" && !window.Manifest) {
      console.error("Error loading Manifest");
    }
  }, [status]);
  useEffect(function () {
    console.log({
      config: config
    });
    if (window.Manifest) {
      var manifestObj = window.Manifest.create(config);
      setManifest(manifestObj);
    }
  }, [config]);
  return {
    open: manifest ? manifest.open : function () {}
  };
};

var useExtractHooks = function () {
  return {
    message: "another mock hooks - fixes trial"
  };
};

var useScript = function (url) {
  useEffect(function () {
    var script = document.createElement("script");
    script.src = url;
    script.async = true;
    document.body.appendChild(script);
    return function () {
      document.body.removeChild(script);
    };
  }, [url]);
};

var useManifestBridge$2 = function (config) {
  var _a = useState(),
    manifest = _a[0],
    setManifest = _a[1];
  var _b = useState(false),
    scriptLoaded = _b[0],
    setScriptLoaded = _b[1];
  useEffect(function () {
    var script = document.createElement("script");
    script.src = MANIFEST_SCRIPT;
    script.async = true;
    script.id = "manifest-bridge-script";
    document.body.appendChild(script);
    setScriptLoaded(true);
    return function () {
      document.body.removeChild(script);
    };
  }, []);
  var loadManifest = useCallback(function (configuration) {
    console.log("load Manifest callback");
    console.log(window.Manifest);
    if (window.Manifest) {
      console.log(window.Manifest);
      var manifestObj = window.Manifest.create(configuration);
      setManifest(manifestObj);
    }
  }, []);
  useEffect(function () {
    console.log({
      scriptLoaded: scriptLoaded
    });
    if (!scriptLoaded) return;
    console.log(window.document.getElementById("manifest-bridge-script"));
    loadManifest(config);
  }, [loadManifest, config, scriptLoaded]);
  return {
    open: manifest ? manifest.open : function () {}
  };
};

var useManifestBridge$1 = function (config) {
  var _a = useState(),
    manifest = _a[0],
    setManifest = _a[1];
  var _b = useState(false),
    scriptLoaded = _b[0],
    setScriptLoaded = _b[1];
  useEffect(function () {
    var script = document.createElement("script");
    script.src = MANIFEST_SCRIPT;
    script.async = false;
    script.id = "manifest-bridge-script";
    document.body.appendChild(script);
    setTimeout(function () {
      return setScriptLoaded(true);
    }, 100);
    return function () {
      document.body.removeChild(script);
    };
  }, []);
  var loadManifest = useCallback(function (configuration) {
    console.log("load Manifest callback");
    console.log(window.Manifest);
    if (window.Manifest) {
      console.log(window.Manifest);
      var manifestObj = window.Manifest.create(configuration);
      setManifest(manifestObj);
    }
  }, []);
  useEffect(function () {
    console.log({
      scriptLoaded: scriptLoaded
    });
    if (!scriptLoaded) return;
    loadManifest(config);
  }, [loadManifest, config, scriptLoaded]);
  return {
    open: manifest ? manifest.open : function () {}
  };
};

var useManifestBridge = function (config) {
  var _a = useState(),
    manifest = _a[0],
    setManifest = _a[1];
  var loading = useScript$2({
    src: MANIFEST_SCRIPT
  })[0];
  useEffect(function () {
    console.log({
      loading: loading
    });
  }, [loading]);
  useEffect(function () {
    console.log({
      config: config
    });
  }, [config]);
  useEffect(function () {
    if (loading) return;
    console.log("reload manifest");
    if (window.Manifest) {
      console.log(window.Manifest);
      var manifestObj = window.Manifest.create(config);
      setManifest(manifestObj);
    }
  }, [config, loading]);
  return {
    open: manifest ? manifest.open : function () {}
  };
};

export { useExtractHooks, useLoadScript, useManifestBridge$3 as useManifestBridge, useManifestBridge$2 as useManifestBridge2, useManifestBridge$1 as useManifestBridge3, useManifestBridge as useManifestBridge4, useScript };
